package b4a.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.ScrollViewWrapper _scrollview1 = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
		Debug.PushSubsStack("Activity_Create (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
anywheresoftware.b4a.objects.drawable.GradientDrawable _gradient_farbe = null;
int[] _farbe = null;
anywheresoftware.b4a.objects.PanelWrapper _panel0 = null;
int _i = 0;
anywheresoftware.b4a.objects.PanelWrapper _panel1 = null;
anywheresoftware.b4a.objects.LabelWrapper _label1 = null;
anywheresoftware.b4a.objects.LabelWrapper _label2 = null;
Debug.locals.put("FirstTime", _firsttime);
 BA.debugLineNum = 30;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
Debug.ShouldStop(536870912);
 BA.debugLineNum = 34;BA.debugLine="Activity.LoadLayout(\"Main\")";
Debug.ShouldStop(2);
mostCurrent._activity.LoadLayout("Main",mostCurrent.activityBA);
 BA.debugLineNum = 35;BA.debugLine="scrollView1.Initialize(300)";
Debug.ShouldStop(4);
mostCurrent._scrollview1.Initialize(mostCurrent.activityBA,(int)(300));
 BA.debugLineNum = 36;BA.debugLine="Activity.AddView(scrollView1,0,00,300,200)";
Debug.ShouldStop(8);
mostCurrent._activity.AddView((android.view.View)(mostCurrent._scrollview1.getObject()),(int)(0),(int)(00),(int)(300),(int)(200));
 BA.debugLineNum = 38;BA.debugLine="Dim gradient_farbe As GradientDrawable";
Debug.ShouldStop(32);
_gradient_farbe = new anywheresoftware.b4a.objects.drawable.GradientDrawable();Debug.locals.put("gradient_farbe", _gradient_farbe);
 BA.debugLineNum = 39;BA.debugLine="Dim farbe(2) As Int";
Debug.ShouldStop(64);
_farbe = new int[(int)(2)];
;Debug.locals.put("farbe", _farbe);
 BA.debugLineNum = 40;BA.debugLine="farbe(0)	=Colors.RGB(255,238,196)";
Debug.ShouldStop(128);
_farbe[(int)(0)] = anywheresoftware.b4a.keywords.Common.Colors.RGB((int)(255),(int)(238),(int)(196));Debug.locals.put("farbe", _farbe);
 BA.debugLineNum = 41;BA.debugLine="farbe(1)	= Colors.RGB(255,238,196) - 40";
Debug.ShouldStop(256);
_farbe[(int)(1)] = (int)(anywheresoftware.b4a.keywords.Common.Colors.RGB((int)(255),(int)(238),(int)(196))-40);Debug.locals.put("farbe", _farbe);
 BA.debugLineNum = 43;BA.debugLine="gradient_farbe.Initialize(\"TOP_BOTTOM\",farbe)";
Debug.ShouldStop(1024);
_gradient_farbe.Initialize(BA.getEnumFromString(android.graphics.drawable.GradientDrawable.Orientation.class,"TOP_BOTTOM"),_farbe);
 BA.debugLineNum = 45;BA.debugLine="Dim Panel0 As Panel";
Debug.ShouldStop(4096);
_panel0 = new anywheresoftware.b4a.objects.PanelWrapper();Debug.locals.put("Panel0", _panel0);
 BA.debugLineNum = 46;BA.debugLine="Panel0 =scrollView1.Panel";
Debug.ShouldStop(8192);
_panel0 = mostCurrent._scrollview1.getPanel();Debug.locals.put("Panel0", _panel0);
 BA.debugLineNum = 47;BA.debugLine="Panel0.Color = Colors.Blue";
Debug.ShouldStop(16384);
_panel0.setColor(anywheresoftware.b4a.keywords.Common.Colors.Blue);
 BA.debugLineNum = 48;BA.debugLine="Panel0.RemoveAllViews";
Debug.ShouldStop(32768);
_panel0.RemoveAllViews();
 BA.debugLineNum = 51;BA.debugLine="For i = 0 To 20";
Debug.ShouldStop(262144);
{
final double step18 = 1;
final double limit18 = (int)(20);
for (_i = (int)(0); (step18 > 0 && _i <= limit18) || (step18 < 0 && _i >= limit18); _i += step18) {
Debug.locals.put("i", _i);
 BA.debugLineNum = 52;BA.debugLine="Dim Panel1 As Panel";
Debug.ShouldStop(524288);
_panel1 = new anywheresoftware.b4a.objects.PanelWrapper();Debug.locals.put("Panel1", _panel1);
 BA.debugLineNum = 53;BA.debugLine="Panel1.Initialize(\"List_Button\")";
Debug.ShouldStop(1048576);
_panel1.Initialize(mostCurrent.activityBA,"List_Button");
 BA.debugLineNum = 54;BA.debugLine="Panel0.Color = Colors.Gray";
Debug.ShouldStop(2097152);
_panel0.setColor(anywheresoftware.b4a.keywords.Common.Colors.Gray);
 BA.debugLineNum = 57;BA.debugLine="Dim Label1, Label2 As Label";
Debug.ShouldStop(16777216);
_label1 = new anywheresoftware.b4a.objects.LabelWrapper();Debug.locals.put("Label1", _label1);
_label2 = new anywheresoftware.b4a.objects.LabelWrapper();Debug.locals.put("Label2", _label2);
 BA.debugLineNum = 58;BA.debugLine="Label1.Initialize(\"\")";
Debug.ShouldStop(33554432);
_label1.Initialize(mostCurrent.activityBA,"");
 BA.debugLineNum = 59;BA.debugLine="Panel1.AddView(Label1,0dip,0dip,100dip,20dip)";
Debug.ShouldStop(67108864);
_panel1.AddView((android.view.View)(_label1.getObject()),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(0)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(0)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(100)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(20)));
 BA.debugLineNum = 60;BA.debugLine="Label1.TextColor = Colors.Black";
Debug.ShouldStop(134217728);
_label1.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 BA.debugLineNum = 61;BA.debugLine="Label1.Text = \"Test \" & i";
Debug.ShouldStop(268435456);
_label1.setText((Object)("Test "+BA.NumberToString(_i)));
 BA.debugLineNum = 63;BA.debugLine="Label2.Initialize(\"\")";
Debug.ShouldStop(1073741824);
_label2.Initialize(mostCurrent.activityBA,"");
 BA.debugLineNum = 64;BA.debugLine="Panel1.AddView(Label2,0dip,21dip,100dip,20dip)";
Debug.ShouldStop(-2147483648);
_panel1.AddView((android.view.View)(_label2.getObject()),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(0)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(21)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(100)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(20)));
 BA.debugLineNum = 65;BA.debugLine="Label2.TextColor = Colors.Black";
Debug.ShouldStop(1);
_label2.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.Black);
 BA.debugLineNum = 66;BA.debugLine="Label2.Text = \"Variable \" & i";
Debug.ShouldStop(2);
_label2.setText((Object)("Variable "+BA.NumberToString(_i)));
 BA.debugLineNum = 68;BA.debugLine="Panel1.Tag = i";
Debug.ShouldStop(8);
_panel1.setTag((Object)(_i));
 BA.debugLineNum = 69;BA.debugLine="Panel1.Background = gradient_farbe";
Debug.ShouldStop(16);
_panel1.setBackground((android.graphics.drawable.Drawable)(_gradient_farbe.getObject()));
 BA.debugLineNum = 70;BA.debugLine="Panel0.AddView(Panel1,0dip,i * 45dip +10dip,100,40dip)";
Debug.ShouldStop(32);
_panel0.AddView((android.view.View)(_panel1.getObject()),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(0)),(int)(_i*anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(45))+anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(10))),(int)(100),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(40)));
 }
}Debug.locals.put("i", _i);
;
 BA.debugLineNum = 74;BA.debugLine="Panel0.Height =i *50dip + 50dip +5dip";
Debug.ShouldStop(512);
_panel0.setHeight((int)(_i*anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(50))+anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(50))+anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(5))));
 BA.debugLineNum = 75;BA.debugLine="End Sub";
Debug.ShouldStop(1024);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_pause(boolean _userclosed) throws Exception{
		Debug.PushSubsStack("Activity_Pause (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
Debug.locals.put("UserClosed", _userclosed);
 BA.debugLineNum = 81;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
Debug.ShouldStop(65536);
 BA.debugLineNum = 93;BA.debugLine="End Sub";
Debug.ShouldStop(268435456);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}
public static String  _activity_resume() throws Exception{
		Debug.PushSubsStack("Activity_Resume (main) ","main",0,mostCurrent.activityBA,mostCurrent);
try {
 BA.debugLineNum = 77;BA.debugLine="Sub Activity_Resume";
Debug.ShouldStop(4096);
 BA.debugLineNum = 79;BA.debugLine="End Sub";
Debug.ShouldStop(16384);
return "";
}
catch (Exception e) {
			Debug.ErrorCaught(e);
			throw e;
		} 
finally {
			Debug.PopSubsStack();
		}}

public static void initializeProcessGlobals() {
    if (mostCurrent != null && mostCurrent.activityBA != null) {
Debug.StartDebugging(mostCurrent.activityBA, 6700, new int[] {3}, "37b31be7-87c8-483c-a4b8-93ea0c626163");}

    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

public static void killProgram() {
    
            if (main.previousOne != null) {
				Activity a = main.previousOne.get();
				if (a != null)
					a.finish();
			}

}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 21;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 26;BA.debugLine="Dim scrollView1 As ScrollView";
mostCurrent._scrollview1 = new anywheresoftware.b4a.objects.ScrollViewWrapper();
 //BA.debugLineNum = 28;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 19;BA.debugLine="End Sub";
return "";
}
  public Object[] GetGlobals() {
		return new Object[] {"Activity",_activity,"scrollView1",_scrollview1};
}
}
